package net.kldp.OpenSigner.utils;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class StringUtil {

public String ascToksc(String str)
	{   
	try
	{
	    if(str == null) return null;
	    return new String(str.getBytes("8859_1"), "KSC5601");
	}
	catch(UnsupportedEncodingException e)
	{
	    System.out.println("Error occured while handling korean character");
	}
	return null;
}   

public static String getFingerprint(byte[] certBytes, String algorithm)
throws NoSuchAlgorithmException
{
	StringBuffer sb = new StringBuffer();

	MessageDigest md = MessageDigest.getInstance(algorithm);
	md.update(certBytes);
	byte[] digest = md.digest();

	sb.append(hexString(digest));

	return sb.toString();
}

private static String hexString(byte[] in)
{
	StringBuffer buffer = new StringBuffer();

	int len = in.length;
	for (int i=0; i<len; i++)
	{
		buffer.append(toHex(in[i]));
		buffer.append(' ');
	}

	return buffer.toString().trim();
}

private static String toHex(byte x)
{
	StringBuffer buffer = new StringBuffer();
	char c;

	c = (char) ((x >> 4) & 0xf);

	if (c > 9) c = (char) ((c - 10) + 'a');
	else c = (char) (c + '0');

	buffer.append (c);

	c = (char) (x & 0xf);

	if (c > 9) c = (char)((c - 10) + 'a');
	else c = (char)(c + '0');

	buffer.append (c);

	return buffer.toString();
}

/**
 * Do newline wrapping of a string
 *
 * @param s
 * @param len
 * @return the wrapped string
 */
public static StringBuffer wrapLines(String s, int len) {

    /* invariant: points at the first character not yet copied */
    int sPos = 0;

    // sanity check
    if (s == null) {
        return null;
    }

    StringBuffer r = new StringBuffer();

    while (sPos < s.length()) {
        r.append(r.length() > 0 ? "\n" : "");
        if (s.length() - sPos <= len) {
            r.append(s.substring(sPos));
            sPos = s.length();
        } else {
            r.append(s.substring(sPos, sPos + len));
            sPos = sPos + len;
        }
    }
    return r;
}

	
}
